using System;
using System.Text;
using ff14bot.Managers;

namespace ff14bot.RemoteWindows
{
    public static class Dawn
    {
        private static readonly string WindowName = "Dawn";

        private static readonly int offset0 = 0x1CA;
        private static readonly int offset2 = 0x160;

        public static int NumberOfTrustsAvailable => ___Elements()[73].TrimmedData;
        public static int SelectedTrustId => ___Elements()[74].TrimmedData;
        public static string SelectedTrustName => Core.Memory.ReadString((IntPtr) ___Elements()[75].Data, Encoding.UTF8);
        
        public static bool IsOpen => RaptureAtkUnitManager.GetWindowByName(WindowName) != null;
        
        private static AtkAddonControl WindowByName => RaptureAtkUnitManager.GetWindowByName(WindowName);

        public static bool CanRegister()
        {
            if (WindowByName == null) return false;
            var remoteButton = WindowByName.FindButton(36);
            return remoteButton != null && remoteButton.Clickable;
        }
        
        public static void Register()
        {
            if (WindowByName != null) WindowByName.SendAction(1, 3, 14);
        }

        public static void SetTrust(int trust)
        {
            if (WindowByName != null) WindowByName.SendAction(2, 3, 15, 4, (ulong) trust);
        }

        public static void Close()
        {
            if (WindowByName != null) WindowByName.SendAction(1, 3, 0);
        }

        public static void PressNpcSelection(int npc)
        {
            if (WindowByName != null && npc < 6) WindowByName.SendAction(2, 3, 12, 4, (ulong) npc);
        }

        public static void ToggleScenario()
        {
            if (WindowByName != null) WindowByName.SendAction(1, 3, 17);
        }
        
        public static TwoInt[] ___Elements()
        {
            var windowByName = RaptureAtkUnitManager.GetWindowByName(WindowName);
            if (windowByName == null) return null;
            var elementCount = ElementCount();
            var addr = Core.Memory.Read<IntPtr>(windowByName.Pointer + offset2);
            return Core.Memory.ReadArray<TwoInt>(addr, elementCount);
        }

        public static ushort ElementCount()
        {
            var windowByName = RaptureAtkUnitManager.GetWindowByName(WindowName);
            return windowByName != null ? Core.Memory.Read<ushort>(windowByName.Pointer + offset0) : (ushort) 0;
        }

    }
}